diff --git a/src/main/java/net/minecraft/server/net/command/commands/ScoreCommand.java b/src/main/java/net/minecraft/server/net/command/commands/ScoreCommand.java
new file mode 100644
index 000000000..997c96d3f
--- /dev/null
+++ b/src/main/java/net/minecraft/server/net/command/commands/ScoreCommand.java
@@ -0,0 +1,88 @@
+package net.minecraft.server.net.command.commands;
+
+import com.mojang.brigadier.CommandDispatcher;
+import com.mojang.brigadier.arguments.IntegerArgumentType;
+import com.mojang.brigadier.builder.LiteralArgumentBuilder;
+import com.mojang.brigadier.builder.RequiredArgumentBuilder;
+import com.mojang.brigadier.exceptions.CommandSyntaxException;
+import net.minecraft.core.entity.Entity;
+import net.minecraft.core.entity.player.Player;
+import net.minecraft.core.net.command.CommandSource;
+import net.minecraft.server.net.command.IServerCommandSource;
+import net.minecraft.core.net.command.arguments.EntityArgumentType;
+import net.minecraft.core.net.command.exceptions.CommandExceptions;
+import net.minecraft.core.net.command.helpers.EntitySelector;
+import net.minecraft.core.net.command.util.CommandHelper;
+import net.minecraft.core.net.packet.UpdatePlayerProfilePacket;
+import net.minecraft.server.MinecraftServer;
+import net.minecraft.server.entity.player.ServerPlayer;
+
+import java.util.List;
+
+public class ScoreCommand {
+    public static void register(CommandDispatcher<CommandSource> dispatcher) {
+        dispatcher.register(LiteralArgumentBuilder.<CommandSource>literal("score")
+            .then(LiteralArgumentBuilder.<CommandSource>literal("get")
+                .executes(c -> {
+                    CommandSource source = c.getSource();
+                    Player player = source.getSender();
+                    if (player == null) throw CommandExceptions.notInWorld().create();
+                    source.sendTranslatableMessage("commands.commander.score.get.success", player.score);
+                    return player.score;
+                })
+                .then(RequiredArgumentBuilder.<CommandSource, EntitySelector>argument("target", EntityArgumentType.player())
+                    .requires(CommandSource::hasAdmin)
+                    .executes(c -> {
+                        CommandSource source = c.getSource();
+                        EntitySelector entitySelector = c.getArgument("target", EntitySelector.class);
+                        Player player = (Player) entitySelector.get(source).get(0);
+                        if (player == source.getSender()) {
+                            source.sendTranslatableMessage("commands.commander.score.get.success", player.score);
+                        } else {
+                            source.sendTranslatableMessage("commands.commander.score.get.success_other", CommandHelper.getEntityName(player), player.score);
+                        }
+                        return player.score;
+                    })))
+            .then(LiteralArgumentBuilder.<CommandSource>literal("set")
+                .requires(CommandSource::hasAdmin)
+                .then(RequiredArgumentBuilder.<CommandSource, EntitySelector>argument("target", EntityArgumentType.players())
+                    .then(RequiredArgumentBuilder.<CommandSource, Integer>argument("score", IntegerArgumentType.integer(0, Integer.MAX_VALUE))
+                        .executes(c -> {
+                            CommandSource source = c.getSource();
+                            EntitySelector entitySelector = c.getArgument("target", EntitySelector.class);
+                            List<? extends Entity> entities = entitySelector.get(source);
+                            int score = c.getArgument("score", Integer.class);
+                            for (Entity entity : entities) {
+                                setPlayerScore(source, (ServerPlayer) entity, score);
+                            }
+                            return score;
+                        }))))
+            .then(LiteralArgumentBuilder.<CommandSource>literal("add")
+                .requires(CommandSource::hasAdmin)
+                .then(RequiredArgumentBuilder.<CommandSource, EntitySelector>argument("target", EntityArgumentType.players())
+                    .then(RequiredArgumentBuilder.<CommandSource, Integer>argument("score", IntegerArgumentType.integer(0, Integer.MAX_VALUE))
+                        .executes(c -> {
+                            CommandSource source = c.getSource();
+                            EntitySelector entitySelector = c.getArgument("target", EntitySelector.class);
+                            List<? extends Entity> entities = entitySelector.get(source);
+                            int score = c.getArgument("score", Integer.class);
+                            for (Entity entity : entities) {
+                                setPlayerScore(source, (ServerPlayer) entity, ((ServerPlayer) entity).score + score);
+                            }
+                            return score;
+                        })))));
+    }
+
+    private static void setPlayerScore(CommandSource source, ServerPlayer player, int score) throws CommandSyntaxException {
+        if (!(source instanceof IServerCommandSource)) throw CommandExceptions.multiplayerWorldOnly().create();
+        MinecraftServer server = ((IServerCommandSource) source).getServer();
+        player.score = score;
+        server.playerList.sendPacketToAllPlayers(new UpdatePlayerProfilePacket(player.username, player.nickname, player.uuid, player.score, player.chatColor, true, player.isOperator()));
+        if (player == source.getSender()) {
+            source.sendTranslatableMessage("commands.commander.score.set.success", score);
+        } else {
+            source.sendTranslatableMessage("commands.commander.score.set.success_other", CommandHelper.getEntityName(player), score);
+            source.sendTranslatableMessage(player, "commands.commander.score.set.success_receiver", score);
+        }
+    }
+}
diff --git a/src/main/java/net/minecraft/server/net/command/commands/StopCommand.java b/src/main/java/net/minecraft/server/net/command/commands/StopCommand.java
new file mode 100644
index 000000000..fbfc0e334
--- /dev/null
+++ b/src/main/java/net/minecraft/server/net/command/commands/StopCommand.java
@@ -0,0 +1,32 @@
+package net.minecraft.server.net.command.commands;
+
+import com.mojang.brigadier.Command;
+import com.mojang.brigadier.CommandDispatcher;
+import com.mojang.brigadier.builder.LiteralArgumentBuilder;
+import net.minecraft.server.MinecraftServer;
+import net.minecraft.core.net.command.CommandSource;
+import net.minecraft.server.net.command.IServerCommandSource;
+import net.minecraft.core.net.command.exceptions.CommandExceptions;
+
+public class StopCommand {
+    public static void register(CommandDispatcher<CommandSource> dispatcher) {
+        dispatcher.register(LiteralArgumentBuilder.<CommandSource>literal("stop")
+                .requires(CommandSource::hasAdmin)
+                .executes(c -> {
+                    CommandSource source = c.getSource();
+                    if (!(source instanceof IServerCommandSource)) throw CommandExceptions.multiplayerWorldOnly().create();
+
+                    MinecraftServer server = ((IServerCommandSource)source).getServer();
+
+                    source.sendTranslatableMessage("commands.commander.stop.success");
+                    if (server.playerList != null) {
+                        server.playerList.savePlayerStates();
+                    }
+                    for (int i = 0; i < server.dimensionWorlds.length; ++i) {
+                        server.dimensionWorlds[i].saveWorld(true, null, true);
+                    }
+                    server.initiateShutdown();
+                    return Command.SINGLE_SUCCESS;
+                }));
+    }
+}
diff --git a/src/main/java/net/minecraft/server/net/command/commands/WhoIsCommand.java b/src/main/java/net/minecraft/server/net/command/commands/WhoIsCommand.java
new file mode 100644
index 000000000..09c82d5b7
--- /dev/null
+++ b/src/main/java/net/minecraft/server/net/command/commands/WhoIsCommand.java
@@ -0,0 +1,29 @@
+package net.minecraft.server.net.command.commands;
+
+import com.mojang.brigadier.Command;
+import com.mojang.brigadier.CommandDispatcher;
+import com.mojang.brigadier.builder.LiteralArgumentBuilder;
+import com.mojang.brigadier.builder.RequiredArgumentBuilder;
+import com.mojang.brigadier.tree.CommandNode;
+import net.minecraft.core.entity.player.Player;
+import net.minecraft.core.net.command.util.CommandHelper;
+import net.minecraft.core.net.command.CommandSource;
+import net.minecraft.core.net.command.arguments.EntityArgumentType;
+import net.minecraft.core.net.command.helpers.EntitySelector;
+
+public class WhoIsCommand {
+    public static void register(CommandDispatcher<CommandSource> dispatcher) {
+        CommandNode<CommandSource> command = dispatcher.register(LiteralArgumentBuilder.<CommandSource>literal("whois")
+                .then(RequiredArgumentBuilder.<CommandSource, EntitySelector>argument("target", EntityArgumentType.player())
+                        .executes(c -> {
+                            CommandSource source = c.getSource();
+                            EntitySelector entitySelector = c.getArgument("target", EntitySelector.class);
+                            Player player = (Player) entitySelector.get(source).get(0);
+
+                            source.sendTranslatableMessage("commands.commander.whois.success", CommandHelper.getEntityName(player), player.username);
+                            return Command.SINGLE_SUCCESS;
+                        })));
+        dispatcher.register(LiteralArgumentBuilder.<CommandSource>literal("realname")
+                .redirect(command));
+    }
+}
diff --git a/src/main/java/net/minecraft/server/net/handler/LoginPacketHandler.java b/src/main/java/net/minecraft/server/net/handler/LoginPacketHandler.java
index 8f350b750..0429c77f2 100644
--- a/src/main/java/net/minecraft/server/net/handler/LoginPacketHandler.java
+++ b/src/main/java/net/minecraft/server/net/handler/LoginPacketHandler.java
@@ -4,6 +4,7 @@ import com.mojang.logging.LogUtils;
 import net.minecraft.core.Global;
 import net.minecraft.core.data.registry.Registries;
 import net.minecraft.core.data.registry.recipe.RecipeEntryBase;
+import net.minecraft.server.net.command.ServerCommandSource;
 import net.minecraft.core.net.handler.PacketHandler;
 import net.minecraft.core.util.helper.UUIDHelper;
 import net.minecraft.server.entity.player.ServerPlayer;
@@ -211,6 +212,7 @@ public class LoginPacketHandler extends PacketHandler
             }
             player.playerNetServerHandler.sendPacket(new PhotoModePacket(mcServer.disablePhotoMode));
             player.playerNetServerHandler.sendPacket(new GameRulePacket(mcServer.getDimensionWorld(0).getLevelData().getGameRules()));
+            player.playerNetServerHandler.sendPacket(new CommandManagerPacket(this.mcServer.getDimensionWorld(player.dimension).getCommandManager().getDispatcher(), new ServerCommandSource(this.mcServer, player), "", 0));
 
             for (RecipeEntryBase<?, ?, ?> recipe : Registries.RECIPES.getAllSerializableRecipes()) {
                 player.playerNetServerHandler.sendPacket(new RecipeSyncPacket(recipe,Registries.RECIPES.getAllSerializableRecipes().size()));
diff --git a/src/main/java/net/minecraft/server/net/handler/ServerPacketHandler.java b/src/main/java/net/minecraft/server/net/handler/ServerPacketHandler.java
index 413f87bc7..471820fca 100644
--- a/src/main/java/net/minecraft/server/net/handler/ServerPacketHandler.java
+++ b/src/main/java/net/minecraft/server/net/handler/ServerPacketHandler.java
@@ -1,5 +1,6 @@
 package net.minecraft.server.net.handler;
 
+import com.mojang.brigadier.exceptions.CommandSyntaxException;
 import com.mojang.logging.LogUtils;
 import net.minecraft.core.block.entity.BlockEntity;
 import net.minecraft.core.block.entity.FlagBlockEntity;
@@ -15,41 +16,10 @@ import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.net.ChatEmotes;
 import net.minecraft.core.net.ICommandListener;
 import net.minecraft.core.net.NetworkManager;
-import net.minecraft.core.net.command.Command;
-import net.minecraft.core.net.command.CommandError;
-import net.minecraft.core.net.command.Commands;
-import net.minecraft.core.net.command.PlayerCommandSender;
-import net.minecraft.core.net.command.ServerCommandHandler;
-import net.minecraft.core.net.command.ServerPlayerCommandSender;
 import net.minecraft.core.net.command.TextFormatting;
+import net.minecraft.server.net.command.ServerCommandSource;
 import net.minecraft.core.net.handler.PacketHandler;
-import net.minecraft.core.net.packet.ChatPacket;
-import net.minecraft.core.net.packet.PlayerCommandPacket;
-import net.minecraft.core.net.packet.InteractPacket;
-import net.minecraft.core.net.packet.KeepAlivePacket;
-import net.minecraft.core.net.packet.MovePlayerPacket;
-import net.minecraft.core.net.packet.Packet;
-import net.minecraft.core.net.packet.ContainerClosePacket;
-import net.minecraft.core.net.packet.ContainerClickPacket;
-import net.minecraft.core.net.packet.ContainerSetSlotPacket;
-import net.minecraft.core.net.packet.ContainerAckPacket;
-import net.minecraft.core.net.packet.UpdateCreativeInventoryPacket;
-import net.minecraft.core.net.packet.SetHotbarOffsetPacket;
-import net.minecraft.core.net.packet.SignUpdatePacket;
-import net.minecraft.core.net.packet.SetMobSpawnerPacket;
-import net.minecraft.core.net.packet.GuidebookPacket;
-import net.minecraft.core.net.packet.SetItemNamePacket;
-import net.minecraft.core.net.packet.SetPaintingArtPacket;
-import net.minecraft.core.net.packet.PlayerActionPacket;
-import net.minecraft.core.net.packet.UseItemPacket;
-import net.minecraft.core.net.packet.SetCarriedItemPacket;
-import net.minecraft.core.net.packet.AnimatePacket;
-import net.minecraft.core.net.packet.CustomPayloadPacket;
-import net.minecraft.core.net.packet.DisconnectPacket;
-import net.minecraft.core.net.packet.BoatControlPacket;
-import net.minecraft.core.net.packet.BlockUpdatePacket;
-import net.minecraft.core.net.packet.UpdatePlayerProfilePacket;
-import net.minecraft.core.net.packet.RespawnPacket;
+import net.minecraft.core.net.packet.*;
 import net.minecraft.core.player.gamemode.Gamemode;
 import net.minecraft.core.player.inventory.menu.FlagMenu;
 import net.minecraft.core.player.inventory.menu.CreativeInventoryMenu;
@@ -535,46 +505,12 @@ public class ServerPacketHandler extends PacketHandler
 
     private void handleSlashCommand(String s)
     {
-        PlayerCommandSender sender = new ServerPlayerCommandSender(mcServer, playerEntity);
-        ServerCommandHandler handler = new ServerCommandHandler(mcServer);
-
-        String[] args = s.substring(1).split(" ");
-        String[] args1 = new String[args.length - 1];
-        System.arraycopy(args, 1, args1, 0, args.length - 1);
-
-        for (Command command : Commands.commands)
-        {
-            if (command.isName(args[0]))
-            {
-                if (!sender.isAdmin() && command.opRequired(args1))
-                {
-                    LOGGER.info("Player {} tried command: {}", sender.getPlayer().username, s);
-                    sender.sendMessage(TextFormatting.RED + "You don't have permission to use this command!");
-                    return;
-                }
-
-                LOGGER.info("Player {} used command: {}", sender.getPlayer().username, s);
-                try
-                {
-                    boolean success = command.execute(handler, sender, args1);
-                    if (!success)
-                    {
-                        command.sendCommandSyntax(handler, sender);
-                    }
-                }
-                catch (CommandError e)
-                {
-                    sender.sendMessage(TextFormatting.RED + e.getMessage());
-                }
-                catch (Throwable e)
-                {
-                    LOGGER.error("Exception while trying to perform command '{}'!", s, e);
-                    sender.sendMessage(TextFormatting.RED + "Error!");
-                }
-                return;
-            }
+        ServerCommandSource serverCommandSource = new ServerCommandSource(mcServer, playerEntity);
+        try {
+            playerEntity.world.getCommandManager().execute(s.substring(1), serverCommandSource);
+        } catch (CommandSyntaxException e) {
+            playerEntity.playerNetServerHandler.sendPacket(new ChatPacket(TextFormatting.RED + e.getMessage(), AES.keyChain.get(playerEntity.username)));
         }
-        sender.sendMessage(TextFormatting.RED + "Command '" + args[0] + "' does not exist!");
     }
 
     @Override
@@ -868,6 +804,21 @@ public class ServerPacketHandler extends PacketHandler
         }
     }
 
+    @Override
+    public void handleRequestCommandManagerPacket(RequestCommandManagerPacket packet) {
+        ServerPlayer player = this.mcServer.playerList.getPlayerEntity(packet.username);
+        if (player == null) return;
+        player.playerNetServerHandler.sendPacket(
+            new CommandManagerPacket(
+                this.mcServer.getDimensionWorld(player.dimension)
+                    .getCommandManager().getDispatcher(),
+                new ServerCommandSource(this.mcServer, player),
+                packet.text,
+                packet.cursor
+            )
+        );
+    }
+
     @Override
     public boolean isServerHandler()
     {
diff --git a/src/main/java/net/minecraft/server/world/WorldServer.java b/src/main/java/net/minecraft/server/world/WorldServer.java
index 4291a924d..b3eaea5b7 100644
--- a/src/main/java/net/minecraft/server/world/WorldServer.java
+++ b/src/main/java/net/minecraft/server/world/WorldServer.java
@@ -5,12 +5,10 @@ import java.util.List;
 
 import net.minecraft.core.Global;
 import net.minecraft.core.block.entity.BlockEntity;
-import net.minecraft.core.entity.animal.Animal;
 import net.minecraft.core.util.collection.IntHashMap;
 import net.minecraft.core.world.*;
 import net.minecraft.core.entity.Entity;
 import net.minecraft.core.entity.player.Player;
-import net.minecraft.core.entity.animal.WaterAnimal;
 import net.minecraft.core.net.command.TextFormatting;
 import net.minecraft.core.util.helper.MathHelper;
 import net.minecraft.core.net.packet.*;
